/**
 * 按钮原子操作执行方法
 * 
 * @param operation
 * @returns
 */
function _operation_originalClickFn(atomicCode, config) {

	// 原子操作映射关系
	var code2Click = {
		"Track" : "stepStopFunc",
		"Comment" : "doZcdbForm",
		"ContinueSubmit" : "doDealForm",
		"Terminate" : "stepStopFunc",
		"Infom" : "addInformFunc",
		"AddNode" : "addNodeFunc",
		"JointSign" : "currentAssignFunc",
		"RemoveNode" : "deleteNodeFunc",
		"moreSign" : "moreSignFunc",
		"Edit" : "doEditContent",
		"Sign" : "openSignature",
		"Cancel" : "dealCancelFunc",
		"SuperviseSet" : "superviseSetFunc",
		"allowUpdateAttachment" : "modifyAttFunc",
		"Transform" : "transformFunc",
		"Transfer" : "transferFunc",
		"Return" : "stepBackFunc",
		"EdocTemplate" : "doTaohong",
		"ScriptTemplate" : "doTaohongForm",
		"TransmitBulletin" : "dealTransmitBulletinFunc",
		"PassRead" : "passReadFunc",
		"HtmlSign" : "doHtmlSign",
		"PDFSign" : "doQwqpHandWrite",
		"SignChange" : "doQwqpSignChange",
		"TurnRecEdoc" : "turnRecEdocFunc",
		"Zhuanshiwu" : "transtoShiwuFunc",
		"Zhuanfawen" : "transtoFawenFunc",
		"SpecifiesReturn" : "appointStepbackFunc",
		"Print" : "printFunc",
		"PrintContentAcc" : "zwPrintFunc",
		"JointlyIssued" : "jointlyIssuedFunc",
		"ContentSign" : "doSignature",
		"TanstoPDF" : "doTransToPdf",
		"TransToOfd" : "doTransToOfd",
        "TransInstructions" : "transInstructionsFunc",
        "Supervise" : "transtoSuperviseFunc",
        "Send" : "saveDealFunc"
	}

	var clickFn = code2Click[atomicCode];

	if (clickFn && typeof window[clickFn] === "function") {

		config = config || {};
		var data = config.data;

		// 执行原子操作
		window[clickFn](data);

	} else {
		if (!clickFn) {
			alert($.i18n("govdoc.Xml.defined.operation") + atomicCode + $.i18n("govdoc.not.define.click"));
		} else {
			alert($.i18n("govdoc.Xml.defined.operation.notFind") + atomicCode + $.i18n("govdoc.not.define.click") + "["
					+ clickFn + "]");
		}
	}
}

/**
 * 按钮显示时按钮置灰校验
 * @param operation
 * @returns
 */
function _operation_filterFn(operation, category){

    
    var disabled = false;
    var remove = false;
    
    
    if(category == DEAL_BTN_CATEGORY_BASE){
        // 基础操作需要对数据做移除
        var excludeArray = ['Track','Archive', 'Comment', 'ContinueSubmit', 
                       'UploadAttachment', 'UploadRelDoc', 'Opinion', 'Print', 
                       "CommonPhrase"];
        
        if ($.inArray(operation.id, excludeArray) > -1) {
            // 过滤按钮
            return {disabled : true, remove : true};
        }
    }
    
    if(hasSubmitButtonFlag == "false"){
        //0：流程调整类、2：提交类、3：意见回复类
        if(operation.type == "0" || operation.type == "2" || operation.type == "3" ){
            disabled = true;
        }
    }
    
    if(!disabled && switchObj.canModifyWorkFlow == 'false'){
        
        var flowChangeArr = ["AddNode","JointSign","RemoveNode","Infom","moreSign"];
        if (operation.hasProcessChange  || operation.type == "0" || $.inArray(operation.id, flowChangeArr) >-1) {
            disabled = true;
            remove = true;
        }
    }
    var inInSpecialSB = false;
    
  //指定回退等状态置灰某些操作
    if (!disabled && ( (affairObj.state == '3' && (affairObj.subState == "15" || affairObj.subState == "16" || affairObj.subState == "17")))) {

            // 移交\加签\减签\当前会签\知会\多级会签 及其封装操作,都不允许操作
            var flowChangeArr = [ "Transfer", "AddNode", "RemoveNode", "JointSign", "Infom", "moreSign" ];
            if (operation.isFlowChange || $.inArray(operation.id, flowChangeArr) > -1) {
                disabled = true;
            }
            
            if (!disabled && operation.codes && operation.codes.length > 0) {
                for (var n = 0; n < operation.codes.length; n++) {
                    if ($.inArray(operation.codes[n], flowChangeArr) > -1) {
                        disabled = true;
                    }
                }
            }

            if(!disabled){
                
                if (affairObj.subState == "16") {
                    // 指定回退只能做提交给我
                    if ($.inArray("Return", operation.codes) > -1 && !operation.isSpecifiesReturnToMe) {
                        disabled = true;
                    }
                } else {
                    // 提交\签章\督办设置\修改正文\修改附件
                    var dontUseArr = [ "ContinueSubmit", "Sign", "SuperviseSet", "Edit", "allowUpdateAttachment" ];
                    if (operation.hasSubmit) {// 提交
                        disabled = true;
                    } else if ($.inArray("Return", operation.codes) > -1) {// 回退与指定回退
                        disabled = true;
                    } else if ($.inArray(operation.id, dontUseArr) > -1) {
                        disabled = true;
                    }
                }
            
        }
    }
    //如果是交换类型 过滤掉指定回退和回退发起人
    if($('#subApp').val() == '4' && !isNaN(operation.id)){
    	// 调用平台分装的ajax方法
        var url = _ctxPath + "/rest/worklfowcomponent/permission/operation/" + operation.id + "?option.n_a_s=1";
        
        jQuery.ajax({
            type: "GET",
            url: url,
            data: null,
            dataType: "json",
            beforeSend: CsrfGuard.beforeAjaxSend,
            async: false,
            success: function(result){
                
                var tempData = result.data;
                
                var wrapContent = $.parseJSON(tempData.content);
                if(wrapContent.returnDetailData && wrapContent.returnDetailData.indexOf('SpecifiesReturn') !=-1){
                	remove = true;
                }
            },
            error: function(){
                alert("get package operation error.");
            }
        });
    }
    var ret = {disabled : disabled, remove : remove}
    return ret;
}

/**
 * 封装动作执行前的校验
 * @param wrapContent
 * @returns
 */
function _operation_packageOperationCheck(wrapContent){
    
    var msg = "";
    var tempIsTemplate = !(!templateId || templateId == '' || templateId == "0" || templateId == "-1");
    var isForm = bodyType == "20";
    if (tempIsTemplate && isForm) {
        return msg;
    }
    
    var jsonObject = wrapContent;
    var specialNodePolicy = new Array();
    if (tempIsTemplate) {
        specialNodePolicy = [ "formaudit", "vouch" ];
    } else {
        specialNodePolicy = [ "formaudit", "vouch", "newsaudit", "bulletionaudit" ];
    }
    
    // 然后判断操作
    if (jsonObject.submitAction != "Return" && jsonObject.processAction != "") {
        
        var changeNodeMessage = jsonObject.processActionDetail;
        if (changeNodeMessage && changeNodeMessage.policyId) {
            var policy = changeNodeMessage.policyId;
            
            var policyArray = [];
            
            if(policy){
                if (jsonObject.processAction != "moreSign") {
                    policyArray.push(policy);
                } else {
                    
                    if(policy instanceof Array){
                        policyArray = policy;
                    }else{
                        policyArray.push(policy);
                    }
                }
            }
            
            var colTypeName = $.i18n("collaboration.eventsource.category.collaboration");
            if (tempIsTemplate) {
                colTypeName = $.i18n("collaboration.saveAsTemplate.collTemplate");
            }
            for (var i = 0; i < policyArray.length; i++) {
                if ($.inArray(policyArray[i], specialNodePolicy) >= 0) {
                    msg = $.i18n("collaboration.canNotDeal.specialNodePolicy.js", $.i18n("node.policy." + policyArray[i]), colTypeName);
                    break;
                }
            }
        }
    }

    var ret = {result : true};
    
    if(msg != ""){
        $.alert(msg);
        ret.result = false;
    }
    
    return ret;
    
}
/**
 * 封装操作， 预提交数据
 * @returns
 */
function _operation_preSubmitData(wrapContent, config){
    
    var fnx = _getZWIframe();
    
    fnx.contentAPI.preSubmit({
        "checkNull" : false,
        "needCheckRule":false,
        "failed" : null,
        "success" : function(_contentObj, snMsg){
            config.success();
        },
        error : function(){
            config.error();
        }
    });
    
}

/**
 * 获取加签/当前会签/知会/多级会签 流程的时候需要设置流程的参数
 * @returns
 */
function _operation_getChangeWorkflowParamFn(type) {

    // 指定回退状态
    var isForm = bodyType == '20';

    var changeWorkflowParam = {
        workitemId : workflowObj.wfItemId,
        processId : workflowObj.wfProcessId,
        nodeId : workflowObj.wfActivityId,
        caseId : workflowObj.wfCaseId,
        appName : "edoc",
        isForm : isForm,
        callback : showWorkflowIframeBefore,
        affairId : affairId,
        useNowexpirationTime : "true",
    }
    
    if(isForm){
        changeWorkflowParam.NPS= "form";
    }else{
        changeWorkflowParam.NPS= "default";
    }
    
    var tempSPK = "";
    switch (type) {
    case "AddNode":
        tempSPK = "insertNode"
        break;
    case "Infom":
        tempSPK = "informNode"
        break;
    case "JointSign":
        tempSPK = "assignNode"
        break;
    case "moreSign":
        tempSPK = "nodeOperation4Account";
        if(!$.ctx.CurrentUser.isAdmin){
            tempSPK = "nodeOperation4Form";
        }
        break;
    default:
        break;
    }
    changeWorkflowParam.SPK = tempSPK;
    
    if(type == "AddNode" || type == "Infom" || type == "JointSign"){
        changeWorkflowParam.performer = gCurrentUser.id;
        changeWorkflowParam.summaryId = summaryId;
        changeWorkflowParam.formRecordId = formRecordid
    }else{
        // 多级会签独有的参数
        changeWorkflowParam.affairMemberId = gCurrentUser.id;
        changeWorkflowParam.workitemId = workflowObj.wfItemId;
//        changeWorkflowParam.formId = formId;
        changeWorkflowParam.flowPermAccountId = gCurrentUser.loginAccount;
        changeWorkflowParam.callBackFn = showWorkflowIframeBefore;
        changeWorkflowParam.selectPeopleDialogLeftTitle  = "";
        changeWorkflowParam.panels = "Department,Team,BusinessDepartment";
    }
    
    if(type == "Infom"){
        changeWorkflowParam.defaultPolicyId = "shenpi";
    }else if(type == "JointSign" ){
        changeWorkflowParam.defaultPolicyId = nodePolicy;
        changeWorkflowParam.defaultPolicyName = nodePolicyName;
    }
    
    if(type == "AddNode" || type == "JointSign"){
        
        changeWorkflowParam.accountId = flowPermAccountId
        
    }else if(type == "moreSign"){
        
        changeWorkflowParam.accountId = gCurrentUser.loginAccount;
        
    }else if(type == "Infom"){
        changeWorkflowParam.accountId = gCurrentUser.loginAccount;
    }
    
    
    if(type == "AddNode" || type == "moreSign"){
        changeWorkflowParam.isTemplete = templateObj.isSysTemplete; 
    }
    
    return changeWorkflowParam;
}

/**
 * 修改流程前事件
 * @param type
 * @returns
 */
function _operation_beforeChangeWorkflowFn(type) {

    switch (type) {
    case "AddNode":
        var idMap = {
            "summaryID" : summaryId,
            "affairID" : affairId
        }
        var sendDevelop = $.ctp.trigger('beforeDealaddnode', idMap);
        if (!sendDevelop) {
            // $.alert($.i18n('collaboration.page.js.third.error.alert.js'));
            return false;
        }
        break;
    case "Infom":
        break;
    case "JointSign":
        break;
    case "moreSign":
        var idMap = {
            "summaryID" : summaryId,
            "affairID" : affairId
        }
        var sendDevelop = $.ctp.trigger('beforeDealaddnode', idMap);
        if (!sendDevelop) {
            return false;
        }
        break;
    default:
        break;
    }

    return true;
}
/***
 * 获取页面上的态度 input dom
 * @param attitudeAction 封装的态度 code
 * @param attitudeShowName 分装的态度名称
 * @returns
 */
function _operation_getAttitudeDomsFn(){
    
    var inputDoms = [];
    
    if(nodeattitudeListSize == "0"){
        
    }else{
        $("input[name='attitude']").each(function(){
            inputDoms.push(this);
        });
    }
    
    return inputDoms;
}

/**
 * 设置态度的值
 * @param value
 * @param code
 * @returns
 */
function _operation_setAttitudeFn(value, code, isClear){
    
	if (isClear) {//清空态度
		document.getElementById("hidAttitude").value = "";
		document.getElementById("hidAttitudeCode").value = "";
	} else {
		document.getElementById("hidAttitude").value = value;
		document.getElementById("hidAttitudeCode").value = code;
	}
    
    $("input[name='attitude']").each(function(){
        
        if(code == this.getAttribute("code")){
            this.checked = true;
            return false;
        }
    });
}

/**
 * 展现流程图的方法
 * @returns
 */
function _operation_refreshWorkflowFn(){
	if(newGovdocView != "0"){
		$("#workflow_view").click();
	}else{
		refreshWorkflow();
	}
}

