$.content.callback = {
	dealSubmit : doDealForm, // 提交回调函数
	dealDraft : doDraftForm, // 存为草稿
	dealZcdb : doZcdbForm, // 暂存待办回调函数
	dealCancel : doCancelForm, // 撤销流程
	dealStepback : doStepbackForm, // 回退
	dealStepStop : doStepStopForm, // 终止
	dealAppointStepback : doAppointStepbackForm,// 指定回退
	dealTransfer : doTransferForm // 移交
};

/**
 * 撤销提交到后台 dealCancelFunc/$.content.callback.dealCancel
 * 
 * @returns
 */
function doCancelForm() {
	if (!checkGovdocComment("dealCancel")){
        submit_callBack_failed();
        return ;
    }
	// 撤销预提交
	if (!executeWorkflowBefore("BeforeCancel")) {
		return;
	}
	// 弹出撤销确认框
	cancelDialog(function(rv) {
		// 将相关意见框的意见同步到主页面
		setOptionParamBeforeSubmit();
		
		var fnx = getZwIframeWindow();
		// 前端设置流程对象参数-content.js中定义
		var domains = [];
		fnx.$.content.getContentDomains(function(domains) {
			// 前端设置意见对象参数-default_govdoc.jsp中定义
			if ($.content.getContentDealDomains(domains)) {
				//检查第三方高级表单
				checkFormThirdSubmit(function() {
					var isWFTrace = true;
					var commentVal = $.trim($("#content_deal_comment").val());
					var _url = _ctxPath + '/govdoc/govdoc.do?method=repeal'
							+ '&affairId=' + affairId + '&summaryId=' + summaryId 
							+ '&repealComment=' + getUrlTxtParam(commentVal) + "&isWFTrace=" + isWFTrace;
					
					// 公文处理界面-撤销提交
					$("#east").jsonSubmit({
						action : _url,
						domains : domains,
						validate : false,
						callback : function(data) {
							closeCollDealPage();
						}
					});
					
				}, "repeal", $("#content_deal_comment").val(), null);//checkFormThirdSubmit end

			}// $.content.getContentDealDomains end
		}, 'repeal', domains, submit_callBack_failed);// fnx.$.content.getContentDomains end
	});// cancelDialog end
}
/**
 * 回退提交到后台 stepBackFunc/$.content.callback.dealStepback
 * 
 * @returns
 */
function doStepbackForm() {
	if (!checkGovdocComment("stepBack")) {
		submit_callBack_failed();
        return;
    }
	// 回退预提交
	if (!executeWorkflowBefore("BeforeStepBack")) {
		return;
	}
	// 将相关意见框的意见同步到主页面
	setOptionParamBeforeSubmit(true);
	// 弹出回退确认框
	stepBackDialog(function(rv) {
		
		// 保存公文正文
		if(!saveDealGovdocBody()){return;}
		// 保存文单签批
		if (!componentDiv.zwIframe.saveHwData()) {
			return;
		}
		// 保存全文签批
		if(typeof(saveQwqp) != "undefined") {
			saveQwqp();	
		}
		
		var fnx = getZwIframeWindow();
		var domains = [];
		// 前端设置流程对象参数到domains (content.js中定义)
		fnx.$.content.getContentDomains(function(domains) {
			// 前端设置意见对象参数 (default_govdoc.jsp中定义)
			if ($.content.getContentDealDomains(domains)) {
				//检查第三方高级表单
				checkFormThirdSubmit(function() {
					var isWFTrace = true;
					
					if (rv.val !=undefined && rv.val != "" && rv.val !="3") {// 没有意见回退时  默认时3  不应该保存，和协同保持一致；
						$("#comment_deal #extAtt1").val(rv.val);
						$("#comment_deal #extAtt4").val(rv.code);
						// collaboration.dealAttitude.disagree 不同意
						// collaboration.dealAttitude.agree 同意
						// collaboration.dealAttitude.haveRead  已阅
					}
					var _url = _ctxPath + '/govdoc/govdoc.do?method=stepBack'
							+ '&affairId=' + affairId + '&summaryId=' + summaryId 
							+ '&isWFTrace=' + isWFTrace + "&isStepBack=1";
					
					// 公文处理界面-回退提交
					$("#layout").jsonSubmit({
						action : _url,
						domains : domains,
						validate : false,
						callback : function(data) {
							closeCollDealPage();
						}
					});
					
				}, "stepBack", $("#content_deal_comment").val(), null);//checkFormThirdSubmit end
				
			}// $.content.getContentDealDomains end
		}, 'stepBack', domains, submit_callBack_failed);// fnx.$.content.getContentDomains end
		
	});//stepBackDialog end
}

/**
 * 指定回退提交到后台 appointStepbackFunc/$.content.callback.dealAppointStepback
 * 
 * @returns
 */
function doAppointStepbackForm(param) {
	if (!checkGovdocComment("specifiesReturn")) {
		submit_callBack_failed();
	    return;
	}
	//弹出指定回退流程图
	var stepBakParams= {};
	stepBakParams.tWindow= getCtpTop();
	stepBakParams.vWindow= getCtpTop();
	stepBakParams.workitemId= affairObj.subObjectId;
	stepBakParams.processId= summaryObj.processId;
	stepBakParams.caseId= summaryObj.caseId;
	stepBakParams.activityId= affairObj.activityId;
	stepBakParams.stepBackToTargetNodeCallBackFn= stepBackToTargetNode1CallBackFn1;
	stepBakParams.showReGo= show1;
	stepBakParams.showToMe= show2;
	if(param){
		stepBakParams.showReGo= param.showReGo;
        stepBakParams.showToMe= param.showToMe;
        stepBakParams.stepBackToNodeId = param.stepBackToNodeId;
    }
	stepBakParams.permissionAccountId= null;
	stepBakParams.appName= "edoc";
	stepBakParams.NPS= "default";
	stepBakParams.isTemplate= templateObj.isFromTemplate;
	stepBakParams.wfTraceType= "";
    stepBakParams.isShowwfTraceButton= true;
    
    
	stepBackToTargetNode(stepBakParams);
}

function stepBackToTargetNode1CallBackFn1(workitemId, processId, caseId, activityId, theStepBackNodeId, submitStyle, flashDialog, theStepBackNodeName, isWFTrace) {
	flashDialog.close();
	$.content.callback.transAppointStepback(workitemId, processId, caseId, activityId, theStepBackNodeId, submitStyle, theStepBackNodeName, isWFTrace);
	
}
function stepBackToTargetNodeCallBack(workitemId, processId, caseId, activityId, theStepBackNodeId, submitStyle, falshDialog,stepBackTargetNodeName,isTraceInt,isCircleBack) {
	$.content.callback.transAppointStepback(workitemId, processId, caseId, activityId, theStepBackNodeId, submitStyle, stepBackTargetNodeName, isTraceInt,isCircleBack);
}

/**
 * 环形回退
 * @param workitemId
 * @param processId
 * @param caseId
 * @param activityId
 * @param theStepBackNodeId
 * @param submitStyle
 * @param isCircleBack
 * @param isTraceInt
 * @param returnValue
 */
function stepBackToTargetNodeCallBackNodialog(workitemId, processId, caseId, activityId, theStepBackNodeId, submitStyle,isCircleBack,isTraceInt,returnValue) {
    //校验处理界面控件
	if (!checkGovdocComment("specifiesReturn")) {
		submit_callBack_failed();
	    return;
	}
    if(typeof(isCircleBack) == undefined){
        isCircleBack =  '';
    }
    $.content.callback.transAppointStepback(workitemId, processId, caseId, activityId, theStepBackNodeId, submitStyle, "", isTraceInt, isCircleBack);
}
/**
 * 指定回退/环形回退提交后到后台
 */
$.content.callback.transAppointStepback = function(workitemId, processId, caseId, activityId, theStepBackNodeId, submitStyle, theStepBackNodeName, isWFTrace, isCircleBack) {
	// 将相关意见框的意见同步到主页面
	setOptionParamBeforeSubmit(true);
	// 弹出指定回退确认框
	stepBackToDialog(function(rv) {
		
		var domains = [];
		// 前端设置意见对象参数 (default_govdoc.jsp中定义)
		if ($.content.getContentDealDomains(domains)) {
			//TODO 指定回退校验接口暂时关闭，分送过后所有节点不能指定回退
			// if(exchangeSendAffairId && exchangeSendAffairId!="")
			// {
             //    var canAppointStep= ajaxManager.checkAppointStepback(activityId,processId,caseId,theStepBackNodeId,exchangeSendAffairId);
             //    if(canAppointStep == "0")
             //    {
             //        $.alert("不能指定回退到分送节点之前或分送节点");
             //        return;
             //    }
			// }

			//检查第三方高级表单
			checkFormThirdSubmit(function() {
				//保存文单数据
				saveGovdocFormData(function() {
					
					if (rv.val != undefined && rv.val != $("#comment_deal #extAtt1").val() && rv.val != 3) {
						$("#comment_deal #extAtt1").val(rv.val);
						$("#comment_deal #extAtt4").val(rv.code);
					}
					
					var _url = _ctxPath + "/govdoc/govdoc.do?method=appointStepBack"
							+ "&workitemId=" + workitemId + "&processId=" + processId + "&caseId="+ caseId + "&activityId=" + activityId + "&summaryId=" + summaryId + "&affairId=" + affairId
							+ "&theStepBackNodeId=" + theStepBackNodeId + "&submitStyle=" + submitStyle
							+ "&isWFTrace=" + isWFTrace;
					if(isCircleBack) {
						_url += "&isCircleBack=" + isCircleBack;
					}

					if(!saveDealGovdocBody()){return;}
					// 公文处理界面-指定回退提交
					$("#layout").jsonSubmit({
						action : _url,
						domains : domains,
						callback : function(data) {
							//saveDealGovdocBody();// 保存公文正文
							closeCollDealPage();
						}
					});
					
				}, submit_callBack_failed, false);// saveGovdocFormData end
			}, "stepBack", $("#content_deal_comment").val(), null);//checkFormThirdSubmit end
			
		}//$.content.getContentDealDomains end
	});
};

/**
 * 终止提交到后台 stepStopFunc/$.content.callback.dealStepStop
 * 
 * @returns
 */
function doStepStopForm() {
	if (!checkGovdocComment("stepStop")) {
		submit_callBack_failed();
	    return;
	}
	// 终止预提交
	if (!executeWorkflowBefore("BeforeStop")) {
		return;
	}
    //调用工作流函数判断是否能够终止
    var result = onBeforeWorkflowOperationValidate(summaryObj.processId, "", affairObj.activityId, summaryObj.caseId, "", "edoc","stepStop");
    var msg= "";
    if(result && !result.pass){
	    msg = result.msg;
    }
    if(msg){
	    $.alert(msg);
        //恢复资源
	    submit_callBack_failed();
        return ;
    }
	// 将相关意见框的意见同步到主页面
	setOptionParamBeforeSubmit(true);
	$("#comment_deal #extAtt1").val($('input[name="attitude"]:checked').val());
	$("#comment_deal #extAtt4").val($('input[name="attitude"]:checked').attr('code'));
	// 弹出终止回退确认框
	stepStopDialog(function(rv) {
		// 消息推送参数设置
		mergeMesPushFun($("#dealMsgPush"), $('#comment_deal #pushMessageToMembers'), $("#content_deal_comment"));
		
		var fnx = getZwIframeWindow();
		var domains = [];
		if (rv.val != undefined && rv.val != $("#comment_deal #extAtt1").val() && rv.val != 3) {
			$("#comment_deal #extAtt1").val(rv.val);
			$("#comment_deal #extAtt4").val(rv.code);
		}
		//把改区域提交上去
		domains.push("comment_deal");
		
		// 公文处理界面-终止提交
		$("#east").jsonSubmit({
			action : _ctxPath + '/govdoc/govdoc.do?method=stepStop&affairId=' + affairId,
			domains : domains,
			validate : false,
			callback : function(data) {
				closeCollDealPage();
			}
		});
		
	});
}

/**
 * 移交提交到后台 transferFunc/$.content.callback.dealTransfer
 * 
 */
function doTransferForm() {
	if (!checkGovdocComment("comDeal")) {
		submit_callBack_failed();
	    return;
	}
	var fnx = getZwIframeWindow();
	// 保存正文
	_confirmSaveAttAndContent(fnx, {
		success : function() {

			var domains = [];
			if ($.content.getContentDealDomains(domains)) {
				domains.push('colSummaryData');
				domains.push('attFileDomain');
				domains.push('assDocDomain');
				domains.push('attActionLogDomain');

				var transferMemberId = $("#transferMemberId").val();
				var url = _ctxPath
						+ '/govdoc/govdoc.do?method=govdocTansfer&affairId='
						+ affairId + '&transferMemberId=' + transferMemberId;
				$("#layout").jsonSubmit({
					action : url,
					domains : domains,
					callback : function(data) {
						closeCollDealPage();
					}
				});
			}
		},// success end
		needSubmit : true,
		checkNull : false,
		needCheckRule : false,
		needCheckRepeatData : false,// 是否校验重复行数据
		"mainbodyDomains" : []
	});// _confirmSaveAttAndContent end
}

/**
 * 存为草稿 saveDraftFunc/$.content.callback.dealDraft
 * 
 */
function doDraftForm() {
//	if (!checkGovdocComment("beforeSaveDraftColl")) {
//		submit_callBack_failed();
//	    return;
//	}
	if ($("#praiseToObj").hasClass("like_16")) {
		$("#praiseInput").val(1);
	} else {
		$("#praiseInput").val(0);
	}
	var draftCommentId = getUUID();
	$("#comment_deal > #id").val(draftCommentId);

	var domains = [];
	if ($.content.getContentDealDomains(domains)) {
		var _url = _ctxPath + '/govdoc/govdoc.do?method=doDraft&affairId=' + affairId + '&summaryId=' + summaryId;
		$("#layout").jsonSubmit({
			action : _url,
			domains : domains,
			callback : function(data) {
				$.infor($.i18n('collaboration.summary.savesucess'));
				
				$("#draftCommentId").val(draftCommentId);
				submit_callBack_failed();
			}
		});
	}// $.content.getContentDealDomains(domains) end
}

/**
 * 暂存待办 saveZcdbFunc/$.content.callback.dealZcdb
 * 
 */
function doZcdbForm(afterZcdbFunc) {
//	if (!checkGovdocComment("zcdb")) {
//		submit_callBack_failed();
//	    return;
//	}
	if ($("#praiseToObj").hasClass("like_16")) {
		$("#praiseInput").val(1);
	} else {
		$("#praiseInput").val(0);
	}
	//设置消息推送参数
	mergeMesPushFun($("#dealMsgPush"), $('#comment_deal #pushMessageToMembers'), $("#content_deal_comment"));
	// 暂存待办情况下，归档无效
	openPigeonholePromptByZcdb(function() {
		
		// 开始遮罩(进度条)
		try { showMask(); } catch (e) {}

		// 将相关意见框的意见同步到主页面
		setOptionParamBeforeSubmit(true);

		var domains = [];
		//addPishiNodeBeforeDeal();
		// 设置流程参数对象到domains
		$.content.getWorkflowDomains($("#moduleType").val(), domains);
		//分保插件-密级做过更改或者流程有变动
		if($.ctx.plugins.contains('secret')) {
			var changeWf = $("#process_message_data").size()>0 && $("#process_message_data").val()!="";
			if(summaryObj.secretLevel != $("#secretLevel").val() || changeWf) {
				if(!checkWfSecretLevel("deal")) {
					submit_callBack_failed();
					return;
				}
			}
		}
		// 保存公文单数据
		saveGovdocFormData(function() {
			//保存附件说明(filesm的值)，这里通过ajax提交到后端
			sendChangeFilesm();
			// 保存附件
			//saveAttachments();
			
			// 保存公文正文
			if (!saveDealGovdocBody()) {
				submit_callBack_failed();
				return;
			}
			//保存ISignaturehtml专业签章
			if (!saveISignature(1)) {
				submit_callBack_failed();
				return;
			}
			// 保存全文签批
			if(typeof(saveQwqp) != "undefined") {
				saveQwqp();	
			}
			// 前端设置意见对象参数-default_govdoc.jsp中定义
			if ($.content.getContentDealDomains(domains)) {
				var fnx = getZwIframeWindow();
				domains.push('colSummaryData');
				domains.push('trackDiv_detail');
				domains.push('superviseDiv');
				domains.push('workflow_definition');
				domains.push('attFileDomain');
				domains.push('assDocDomain');
				domains.push('attActionLogDomain');
				domains.push('markParam');
				domains.push(fnx.getMainBodyDataDiv());

				var govdocContent = document.getElementById("newPdfIdFirst").value;
				var isConvertPdf = false;
				if ("isConvertPdf" == document.getElementById("isConvertPdf").value) {
					isConvertPdf = true;
				}
				var _url = _ctxPath
						+ '/govdoc/govdoc.do?method=doZCDB&affairId=' + affairId + '&processId=' + summaryObj.processId
						+ '&govdocContent=' + govdocContent
						+ '&isConvertPdf=' + isConvertPdf
						+ "&customDealWith=" + ($("#customDealWith").attr("checked") == 'checked') + "&permissionRange=" + $("#permissionRange option:selected").val() + "&memberRange=" + $("#memberRange option:selected").val()
						+ "&distributeType=" + $("#distributeType").val()
						+ "&leaderPishiType=" + $("#leaderPishiType").val();
				savePishiDealInfo();
				// 公文处理界面-暂存待办提交
				$("#layout").jsonSubmit({
					action : _url,
					domains : domains,
					isMask : false,
					callback : function(data) {
						
						if(afterZcdbFunc && typeof(afterZcdbFunc) =='function') {
							afterZcdbFunc();
						} else {
							closeCollDealPage();
						}
					}
				});// jsonSubmit end
				
			}// $.content.getContentDealDomains
		}, submit_callBack_failed, true);// saveGovdocFormData end
	}, submit_callBack_failed);// openPromptByPigeonhole end
}

/**
 * 提交 saveDealFunc/$.content.callback.dealSubmit
 * 
 */
var subCount = 0;
function doDealForm() {
	//1校验意见
	if (!checkGovdocComment("comDeal")) {
		submit_callBack_failed();
	    return;
	}
	//2 校验当前待办公文是否可用
	if (!isAffairValid(affairId,true)) {
		submit_callBack_failed();
		return;
	}
	//验证归档文件夹是否有相同文件
	if (!checkPigeonholeRepeat()) {
		enableOperation();
		setButtonCanUseReady();
		return;
	}

	// 将相关意见框的意见同步到主页面
	setOptionParamBeforeSubmit(true);
	//弹出同意不同意选择框
	disagreeDealDialog(function() {
		
		if ($("#praiseToObj").hasClass("like_16")) {
			$("#praiseInput").val(1);
		} else {
			$("#praiseInput").val(0);
		}
		subCount = addOneSub(subCount);
		if (parseInt(subCount) >= 2) {
			// 不能重复提交，用最原生的alert，$.ALERT不能阻塞，太慢了才弹出
			alert($.i18n("collaboration.summary.notDuplicateSub"));
			submit_callBack_failed();
			return;
		}

		// 开始遮罩(进度条)
		try { showMask();v3x.lastWindow.close(); } catch (e) {}
			
		//文单选择意见展示3，被回退节点提交时弹出意见显示最后一次提示框
		stepbackSetDialog(function() {
			var domains = [];
			//代录批示加签节点
		    addPishiNodeBeforeDeal();
			//设置意见对象到domains
			$.content.getWorkflowDomains($("#moduleType").val(), domains);
			
			//定义流程结束处理后的后续操作，也就是下边fnx.preSubmitData的回调方法
			$.content.callback.workflowFinish = function() {
				//分保插件-密级做过更改或者流程有变动
				if($.ctx.plugins.contains('secret')) {
					var changeWf = $("#process_message_data").size()>0 && $("#process_message_data").val()!="";
					if(summaryObj.secretLevel != $("#secretLevel").val() || changeWf) {
						if(!checkWfSecretLevel("deal")) {
							submit_callBack_failed();
							return;
						}
					}
				}
				//验证文号，因为需要用到当前流程是否即将结束
				if(!checkFormMark("deal")) {
					submit_callBack_failed();
			 		return;
			 	}
				
				//保存公文单数据
				saveGovdocFormData(function() {
					//判断本次提交的操人是否为：转公告、转新闻
					bulnewsFunc(function() {
						var rv = $.content.getContentDealDomains(domains);
						if (rv == false) {
							submit_callBack_failed();
							return;
						}
						
						//保存附件说明(filesm的值)，这里通过ajax提交到后端
						sendChangeFilesm();
						//保存附件  注释掉 后台有单独的保存附件
						//saveAttachments();
						//保存公文正文
						if(!saveDealGovdocBody(null,true)){
							submit_callBack_failed();
							return;
						}
						// 刷新意见区
						refreshComment();
						//保存公文正文章
						doSaveSign();
						// 保存ISignaturehtml专业签章
						if (!saveISignature(1)) {
							submit_callBack_failed();
							return;
						}
						// cx 提交全文签批
						// 保存全文签批
						if(typeof(saveQwqp) != "undefined") {
							saveQwqp();	
						}
						//设置前端对象到domains
						domains.push('colSummaryData');
						domains.push('trackDiv_detail');
						domains.push('superviseDiv');
						domains.push('workflow_definition');
						domains.push('attFileDomain');
						domains.push('assDocDomain');
						domains.push('attActionLogDomain');
						domains.push('markParam');
						domains.push(fnx.getMainBodyDataDiv());

						//设置回复态度
						var attitudeArray = document .getElementsByName("attitude");
						for (var i = 0; i < attitudeArray.length; i++) {
							if (attitudeArray[i].checked) {
								attitudeArray = attitudeArray[i].value;
								break;
							}
						}
						//检查第三方高级表单
						checkFormThirdSubmit( function() {

							mergeMesPushFun( $("#dealMsgPush"), $('#comment_deal #pushMessageToMembers'), $("#content_deal_comment"));

							var _url = _ctxPath
										+ '/govdoc/govdoc.do?method=finishWorkItem'
										+ '&affairId=' + affairId + "&app=" + $("#app").val()
										+ "&customDealWithActivitys=" + $("#customDealWithActivitys").val()
										+ "&leaderPishiType=" + $("#leaderPishiType").val();
							var pigeonholeValue = $("#pigeonholeValue").val();
							if (pigeonholeValue && pigeonholeValue != "cancel") {
								var pigeonhole = pigeonholeValue.split(",");
								_url += '&pigeonholeValue=' + pigeonhole[0];
							}
							if(document.getElementById("isNotEdit")) {
								_url += '&isNotEdit=' + document.getElementById("isNotEdit").value;	
							}
							if(document.getElementById("duanxintixing")) {
								_url += '&duanxintixing=' + document.getElementById("duanxintixing").value;	
							}
							
							var govdocContent = document.getElementById("newPdfIdFirst").value;
							var isConvertPdf = false;
							if ("isConvertPdf" == document.getElementById("isConvertPdf").value) {
								isConvertPdf = true;
							}
							_url += '&govdocContent=' + govdocContent + '&isConvertPdf=' + isConvertPdf;
							var reSign = document.getElementById("reSign");
							if (reSign && reSign.value == "1") {
								_url += '&reSign=1';
							}
							//打印参数
							_url += getPrintUrlParam();
							
							//保存代录批示进缓存
							savePishiDealInfo();
							//公文处理界面-提交
							$("#layout").jsonSubmit({
								action : _url,
								domains : domains,
								isMask : false,
								callback : function(data) {
									submit_callBack_failed();
									closeCollDealPage();
								}
							});
						}, attitudeArray, $("#content_deal_comment").val(), null);// checkFormThirdSubmit end
					
					});//bulnewsFunc end
				});//saveGovdocFormData end
			};//$.content.callback.workflowFinish end

			var fnx = getZwIframeWindow();
			fnx.preSubmitData(function() {
				//预提交
				if (!executeWorkflowBeforeEvent("BeforeFinishWorkitem", summaryId, affairId, summaryObj.processId, summaryObj.processId, workflowObj.wfActivityId, formRecordid, workflowObj.moduleTypeName,null,null,null,$("#process_xml").val())) {
					return;
				}
				
				/*preSendOrHandleWorkflow(window, workflowObj.wfItemId, workflowObj.wfProcessId, workflowObj.wfProcessId, workflowObj.wfActivityId,
	 gCurrentUser.id, workflowObj.wfCaseId, gCurrentUser.loginAccount, formRecordid, workflowObj.moduleTypeName, $("#process_xml").val(), 
		false, $("#subApp").val());
		*/

		        var options = {
		           		tWindow : window,
		           		workitemId : workflowObj.wfItemId,
		           		processTemplateId : workflowObj.wfProcessId,
		           		processId : workflowObj.wfProcessId,
		           		activityId : workflowObj.wfActivityId,
		           		currentUserId : gCurrentUser.id,
		           		caseId : workflowObj.wfCaseId,
		           		currentAccountId : gCurrentUser.loginAccount,
		           		formData : formRecordid,
		           		appName : workflowObj.moduleTypeName,
		           		currentWorkItemIsInSpecial:workflowObj.currentWorkItemIsInSpecial,
		           		processXml : $("#process_xml").val(),
		           		fn: $("#subApp").val()
		           }
		           
		        preSendOrHandleWorkflow(options);
				
				
			}, submit_callBack_failed, true);// fnx.preSubmitData end
			
		});//stepbackSetDialog end

	}, stepBackFunc, doStepStopForm, dealCancelFunc,doAppointStepbackForm);//disagreeDealDialog end
}

//保存公文单数据
function saveGovdocFormData(dealFn, closeFn, isDoZcdb) {
	var fnx = getZwIframeWindow();
	if (fnx.contentUpdate)
		fnx.$("#viewState").val("1");
	if (fnx.$("#viewState").val() == "1" || bodyType == '20') {
		var domains = [];
		fnx.saveOrUpdate({
			success : dealFn,
			failed : closeFn,
			needSubmit : true,
			"mainbodyDomains" : domains,
			checkNull : false,
			needCheckRule : false,
			isGovDoZcdb : isDoZcdb
		});
	} else {
		dealFn();
	}
}

function getPrintUrlParam() {
	var printParam = "";
	// 打印设置
	if ($("#printSetData").length == 1) {
		if ($("#checkPrint").length == 1 && $("#checkPrint")[0].checked) {
			var mainNum = $('#mainNum').val();
			var copyNum = $('#copyNum').val();
			var send_to = '';
			var copy_to = '';
			var zw = componentDiv.zwIframe.document;
			var fieldVal;
			if ($(zw).find("[mappingField='send_to']").length > 0) {
				// 获取主送单位
				try {
					var span = $(zw).find("[mappingField='send_to']").parent("span");
					if (span.find("input").length == 1) {
						fieldVal = span.find("input").val();
						send_to = fieldVal;
					}
					if (send_to == "") {
						fieldVal = span.attr("fieldVal");
						fieldVal = $.parseJSON(fieldVal);
						send_to = fieldVal.value;
					}
				} catch (e) {
				}
			} else {// $(zw).find("[mappingField='send_to']").length > 0 end
				try {
					// 获取主送单位
					var span = window.rightViewElementIframe.$("[mappingField='send_to']").parent("span");
					if (span.find("input").length == 1) {
						fieldVal = span.find("input").val();
						send_to = fieldVal;
					}
					if (send_to == "") {
						fieldVal = span.attr("fieldVal");
						fieldVal = $.parseJSON(fieldVal);
						send_to = fieldVal.value;
					}
				} catch (e) {
				}
			}// $(zw).find("[mappingField='send_to']").length <= 0

			if ($(zw).find("[mappingField='copy_to']").length > 0) {
				// 获取抄送单位
				try {
					var span = $(zw).find("[mappingField='copy_to']").parent("span");
					if (span.find("input").length == 1) {
						fieldVal = span.find("input").val();
						copy_to = fieldVal;
					}
					if (copy_to == "") {
						fieldVal = span.attr("fieldVal");
						fieldVal = $.parseJSON(fieldVal);
						copy_to = fieldVal.value;
					}
				} catch (e) {
				}
			} else {// $(zw).find("[mappingField='copy_to']").length > 0 end
				try {
					// 获取抄送单位
					var span = window.rightViewElementIframe.$("[mappingField='copy_to']").parent("span");
					if (span.find("input").length == 1) {
						fieldVal = span.find("input").val();
						copy_to = fieldVal;
					}
					if (copy_to == "") {
						fieldVal = span.attr("fieldVal");
						fieldVal = $.parseJSON(fieldVal);
						copy_to = fieldVal.value;
					}
				} catch (e) {}
			}// $(zw).find("[mappingField='copy_to']").length <= 0 end

			var printSetData = $("#printSetData").val();
			var newPrintSetDataArray = printSetData.split(',');
			// 需要处理默认值
			if (mainNum != '' && send_to != '') {
				var array = send_to.split(',');
				for (var i = 0; i < array.length; i++) {
					var str1 = array[i];
					if (str1.indexOf('|') == -1) {
						continue;
					}
					var arr1 = str1.split('\|');
					var isContains = false;
					for (var j = 0; j < newPrintSetDataArray.length; j++) {
						if (newPrintSetDataArray[j].indexOf(arr1[1]) != -1) {
							isContains = true;
							break;
						}
					}
					if (!isContains) {
						newPrintSetDataArray.push(str1 + "|" + mainNum);
					}
				}// for end
			}// mainNum!='' && send_to !='' end

			if (copyNum != '' && copy_to != '') {
				var array = copy_to.split(',');
				for (var i = 0; i < array.length; i++) {
					var str1 = array[i];
					if (str1.indexOf('|') == -1) {
						continue;
					}
					var arr1 = str1.split('\|');
					var isContains = false;
					for (var j = 0; j < newPrintSetDataArray.length; j++) {
						if (newPrintSetDataArray[j].indexOf(arr1[1]) != -1) {
							isContains = true;
							break;
						}
					}
					if (!isContains) {
						newPrintSetDataArray.push(str1 + "|" + copyNum);
					}
				}
			}// copyNum!='' && copy_to!='' end
			printParam += '&printSetData=' + newPrintSetDataArray.join(',');
		}// $("#checkPrint").length == 1 && $("#checkPrint")[0].checked end
	}// $("#printSetData").length==1 end
	return printParam;
}

function openPigeonholePromptByZcdb(okFun, closeFn) {
	if ($("#pigeonhole").length > 0 && $("#pigeonhole")[0].checked) {
		$.messageBox({
			'title' : $.i18n('collaboration.system.prompt.js'), // 系统提示
			'type' : 0,
			'imgType' : 2,
			'msg' : $.i18n('govdoc.archive.invalid'),
			ok_fn : function() {
				okFun();
			},
			close_fn : closeFn
		});
	} else {
		okFun();
	}
}

function cancelDialog(dealFn) {
	// 弹出撤销意见框
	var bottomHTML = '';
	bottomHTML += '<label  class="margin_t_5 hand" style="display: inline-block;width: 190px;text-align: left;position: relative;top: -7px;">';
	bottomHTML += $.i18n("govdoc.workflow.trace.summary");
	bottomHTML += '</label>';
	var dialog = $.dialog({
		targetWindow : getCtpTop(),
		id : 'cancelDialog',
		bottomHTML : bottomHTML,
		url : _ctxPath + "/collaboration/collaboration.do?method=repealDialog&affairId=" + affairId,
		width : 450,
		height : 180,
		title : $.i18n("govdoc.system.hint"),
		closeParam : {
			show : true,
			autoClose : true,
			handler : function() {
				submit_callBack_failed();
			}
		},
		buttons : [{
			text : $.i18n('collaboration.pushMessageToMembers.confirm'), // 确定
			handler : function() {
				var rv = dialog.getReturnValue();
				if (!rv) {
					return;
				}
				dialog.close();// 关闭dialog

				dealFn(rv);
			}// handler end
		}, 	{// buttons
			text : $.i18n('collaboration.pushMessageToMembers.cancel'), // 取消
			handler : function() {
				dialog.close();
				submit_callBack_failed(12);
			}
		}]// button 确定 end
	});// dialog end
}

function stepBackDialog(dealFn) {
	var permissionId = $("#permissionId").val();
	// 弹出撤销意见框
	var bottomHTML = '';
	bottomHTML += '<label  class="margin_t_5 hand" style="display: inline-block;width: 190px;text-align: left;position: relative;top: -7px;">';
	bottomHTML += $.i18n("govdoc.workflow.trace.summary");
	bottomHTML += '</label>';
	var dialog = $.dialog({
		targetWindow : getCtpTop(),
		id : 'stepbackdialog',
		bottomHTML : bottomHTML,
		url : _ctxPath + "/collaboration/stepBack.do?method=stepBackDialog&affairId=" + affairId+"&permissionId="+encodeURIat($("#permissionId").val()),
		width : 450,
		height : 180,
		title : $.i18n("govdoc.system.hint"),
		closeParam : {
			show : true,
			autoClose : true,
			handler : function() {
				submit_callBack_failed();
			}
		},
		buttons : [{
			text : $.i18n('collaboration.pushMessageToMembers.confirm'), // 确定
			handler : function() {
				var rv = dialog.getReturnValue();
				if (!rv) {
					return;
				}
				dialog.close();// 关闭dialog

				dealFn(rv);
			}// handler end
		}, 	{// buttons
			text : $.i18n('collaboration.pushMessageToMembers.cancel'), // 取消
			handler : function() {
				dialog.close();
				submit_callBack_failed(12);
			}
		}]// button 确定 end
	});// dialog end	
}

function stepBackToDialog(dealFn) {
	var permissionId = $("#permissionId").val();
	var bottomHTML = '';
	bottomHTML += '<label  class="margin_t_5 hand" style="display: inline-block;width: 190px;text-align: left;position: relative;top: -7px;">';
	bottomHTML += $.i18n("govdoc.workflow.trace.summary");
	bottomHTML += '</label>';
	var dialog = $.dialog({
		targetWindow : getCtpTop(),
		id : 'stepBackToDialog',
		bottomHTML : bottomHTML,
		url : _ctxPath + "/collaboration/stepBack.do?method=stepBackToDialog&affairId=" + affairId+"&permissionId="+encodeURIat($("#permissionId").val()),
		width : 400,
		height : 180,
		title : $.i18n('collaboration.system.prompt.js'), // 系统提示
		closeParam : {
			show : true,
			autoClose : true,
			handler : function() {
				submit_callBack_failed(10);
			}
		},
		buttons : [{
			text : $.i18n('collaboration.pushMessageToMembers.confirm'), // 确定
			handler : function() {
				var rv = dialog.getReturnValue();
				if (!rv) {
					return;
				}
				dialog.close();// 关闭dialog

				dealFn(rv);
			}//handler end
		}, {// buttons
			text : $.i18n('collaboration.pushMessageToMembers.cancel'), // 取消
			handler : function() {
				dialog.close();
				submit_callBack_failed(10);
			}
		}]// button 确定 end		
	});// dialog end
}

function stepStopDialog(dealFn) {
	var permissionId = $("#permissionId").val();
	var dialog = $.dialog({
		targetWindow : getCtpTop(),
		id : 'stepStopToTargetDialog',
		url : _ctxPath + "/collaboration/stepBack.do?method=stepStopDialog&affairId=" + affairId+"&permissionId="+encodeURIat($("#permissionId").val()),
		width : 400,
		height : 180,
		title : $.i18n('collaboration.system.prompt.js'), // 系统提示
		closeParam : {
			show : true,
			autoClose : true,
			handler : function() {
				submit_callBack_failed(11);
			}
		},
		buttons : [{
			text : $.i18n('collaboration.pushMessageToMembers.confirm'), // 确定
			handler : function() {
				var rv = dialog.getReturnValue();
				if (!rv) {
					return;
				}
				dialog.close();// 关闭dialog

				dealFn(rv);
			}//handler
		}, {//buttons
			text : $.i18n('collaboration.pushMessageToMembers.cancel'), // 取消
			handler : function() {
				dialog.close();
				submit_callBack_failed(11);
			}
		}]// button 确定 end
	});// dialog end
}

function disagreeDealDialog(dealFn, stepBackFn, stepStopFn, cancelFn, doAppointStepbackForm) {
	// 当态度为"不同意"时做的一些判断
	if ($("input[name='attitude']:checked").attr("code") == "disagree") {
		var isdealStepBackShow = false;//policyContains("Return");
		var isdealStepStopShow = false;//policyContains("Terminate");
		var isdealCancelShow = false;//policyContains("Cancel");

		//是否显示指定回退
        var isdealSpecifiesReturnShow = false;
        //回退 return 改为-1  指定回退 SpecifiesReturn -2
        if ((nodePerm_commonActionList && (nodePerm_commonActionList.contains('-1' )||nodePerm_commonActionList.contains('Return' )))
                ||(nodePerm_advanceActionList && (nodePerm_advanceActionList.contains('-1' )||nodePerm_advanceActionList.contains('Return' )))){
            isdealStepBackShow = true ;
        }else{
        	optionalAction = optionalAction.replace(",-1","");
        }

        if ((nodePerm_commonActionList && nodePerm_commonActionList.contains('Terminate' ))
                ||(nodePerm_advanceActionList && nodePerm_advanceActionList.contains('Terminate' ))){
            isdealStepStopShow = true ;
        }else{
        	optionalAction = optionalAction.replace(",Terminate","");
        }

        if ((nodePerm_commonActionList && nodePerm_commonActionList.contains('Cancel' ))
                ||(nodePerm_advanceActionList && nodePerm_advanceActionList.contains('Cancel' ))){
        	var repeal = canRepeal('collaboration', summaryObj.processId, workflowObj.wfActivityId);
        	if (repeal[0] === 'false' ){//不能撤销流程
        		optionalAction = optionalAction.replace(",Cancel","");
        	}else{
        		isdealCancelShow = true ;
        	}
        }else{
        	optionalAction = optionalAction.replace(",Cancel","");
        }
        //指定回退
        if ((nodePerm_commonActionList &&( nodePerm_commonActionList.contains('-2' )||nodePerm_commonActionList.contains('SpecifiesReturn' )))
                ||(nodePerm_advanceActionList && (nodePerm_advanceActionList.contains('-2' )||nodePerm_advanceActionList.contains('SpecifiesReturn' )))){
        	isdealSpecifiesReturnShow = true ;
        }else{
        	optionalAction = optionalAction.replace(",-2","");
        }
        
		// 节点权限没有回退、撤销、终止,系统不会弹出确认框，直接可以提交成功
		if (isdealStepBackShow || isdealStepStopShow || isdealCancelShow||isdealSpecifiesReturnShow) {
			if(isOptional == "0" || optionalAction.indexOf(",") == '-1'){//优化点：不同意策略中只有一个操作时，不再弹出确认框
        		if (defaultAction  == "Return" || defaultAction  == "-1"){//回退
        			stepBackFn();
                } else if (defaultAction  == "Terminate"){//终止
                	stepStopFn();
                } else if (defaultAction  == "Cancel"){//撤销
                	cancelFn();
                } else if (defaultAction  == "SpecifiesReturn" || defaultAction  == "-2"){//指定回退
                	doAppointStepbackForm();
                }else if (defaultAction  == "Continue"){//继续
                	dealFn();
                }
            }else{
				var _url = _ctxPath + "/govdoc/govdoc.do?method=disagreeDealDialog";
				_url += "&isOptional="+isOptional+"&optionalAction="+optionalAction+"&defaultAction="+defaultAction;
				if (!isdealStepBackShow) {
					_url += "&stepBack=hidden";
				}
				if (!isdealStepStopShow) {
					_url += "&stepStop=hidden";
				}
				if (!isdealCancelShow) {
					_url += "&repeal=hidden";
				}
				if (!isdealSpecifiesReturnShow){
					_url += "&specifiesReturn=hidden" ;
				}
				if (affairObj.state == '3' && affairObj.state == '16') {
					_url += "&disableTB=1";
				}
				var dialog = $.dialog({
					url : _url,
					title : $.i18n('collaboration.system.prompt.js'), // 系统提示
					width : 500,
					height : 120,
					targetWindow : getCtpTop(),
					buttons : [{
						text : $.i18n('collaboration.pushMessageToMembers.confirm'), // 确定
						handler : function() {
							var rv = dialog.getReturnValue();
							if (!rv) {
								return;
							}
							dialog.close();

							if (rv == "continue") {
								dealFn();
							} else if (rv == "stepBack") {
								stepBackFn();
							} else if (rv == "stepStop") {
								stepStopFn();
							} else if (rv == "repeal") {
								cancelFn();
							} else if (rv == "specifiesReturn"){
								doAppointStepbackForm();
							}
						}
					}, {
						text : $.i18n('collaboration.pushMessageToMembers.cancel'), // 取消
							handler : function() {
						submit_callBack_failed();
								dialog.close();
							}
					} ],// buttons end
					closeParam : {
						'show' : true,
						handler : function() {
							submit_callBack_failed();
						}
					}
				});// dialog end
            }
		}else{
			dealFn();
		}
		//isdealStepBackShow || isdealStepStopShow || isdealCancelShow end
	} else {
		dealFn();
	}
}

function stepbackSetDialog(dealFn) {
	if (isAlertStepbackDialog == "true") {
		//判断当前节点对公文意见元素是否有编辑权限
		// var zwIframe = $(componentDiv.zwIframe.document);
		// var edocflowdealoption = formZwIframe.find("span[fieldval*='edocflowdealoption']");
		// var hasEditOptionRole = false;
		// if(edocflowdealoption.size() > 0) {
		// 	for(var i=0; i<edocflowdealoption.size(); i++) {
		// 		var optionObj =  edocflowdealoption.get(i);
		// 		if(optionObj.className && optionObj.className!="" && optionObj.className.indexOf("edit_class")>=0) {
		// 			hasEditOptionRole = true;
		// 			break;
		// 		}
		// 	}
		// }
		if(opinionType == '3' || opinionType == '4') {
			// OA-21323 后台设置意见保留方式又被退回人选择。被退回人在提交时选择"保留最后一次意见"，但是处理后，他所有的意见都保留了
			// 加了affairId参数
			var _url = "/seeyon/govdoc/govdoc.do?method=opinionSetDialog"
					+ "&opinionType=" + opinionType + "&summaryId=" + summaryId
					+ "&policy=" + encodeURIComponent(nodePolicy) + "&affairId="
					+ affairId + "&ndate=" + new Date().getTime();
			var dialog = $.dialog({
				url : _url,
				title : $.i18n("govdoc.opinion.retention.settings"),
				width : 260,
				height : 150,
				overflow : 'hidden',
				targetWindow : getCtpTop(),
				transParams : window,
				closeParam : {
					'show' : true,
					autoClose : false,
					handler : function() {
						dialog.close();
						
						submit_callBack_failed();
					}
				},
				buttons : [ {
					text : $.i18n("govdoc.confirm"),
					handler : function() {
						var rv = dialog.getReturnValue();
						dialog.close();
						
						$("#colSummaryData").find("#chooseOpinionType").val(rv);
						dealFn();
					}
				}, {
					text : $.i18n("govdoc.shutdown"),
					handler : function() {
						dialog.close();
						submit_callBack_failed();
					}
				} ]
			});// dialog end
		} else {
			dealFn();	
		}
	} else {
		dealFn();
	}
}

function bulnewsFunc(dealFn) {
	if (nodePolicy == "bulletionaudit") {
		bulletinIssue(summaryId, affairId, bodyType, sub, rightId, submit_callBack_failed);
	} else if (nodePolicy == "newsaudit") {
		newsIssue(summaryId, affairId, bodyType, sub, rightId, submit_callBack_failed);
	} else {
		if ($("#isDistribureOperate").val() != "1") {
			dealFn();
		}
	}
}

//提交交处理意见参数
function setOptionParamBeforeSubmit(isUpdateToForm) {
	//拟办意见处理
	try{
		var nibanyijian = $(window.frames["componentDiv"].frames["zwIframe"].document).find("[mappingField=nibanyijian]");
		if(nibanyijian){
			var fieldVal = nibanyijian.parent().attr("fieldVal");
			fieldVal = $.parseJSON(fieldVal);
			var oldValue = fieldVal.value.replace("\u000a","").replace(/\s/g,"");
			var newValue = nibanyijian.text().trim().replace(/\s/g,"");
			if(oldValue!=newValue){
				$("#comment_deal #opinionex").remove();
				$("#comment_deal").append("<input type='hidden' id='opinionex' value='"+nibanyijian.text()+"'/>");
			}
		}
	}catch(e){}
	
	//点击确认或者暂存待办前，把文单中意见处理框的值传递到此页面  zhangdong 20170329 start
	if(isUpdateToForm) {
		var zwIframe = componentDiv.zwIframe;
		//意见态度
		var childrenPageAttitude = zwIframe.document.getElementsByName("attitude");
		
		if(childrenPageAttitude){
		    for(var i=0;i<childrenPageAttitude.length;i++){
		       if(childrenPageAttitude[i].checked==true){
		    	   	//由于多视图的原因
		    	    var j = i%attitudeNum;
		      	 	document.getElementsByName("attitude")[j].checked=true;
		       }
		    }
		}
		
		//意见处理
		if(zwIframe.document.getElementById("contentOP")){
			  document.getElementById("content_deal_comment").value=zwIframe.document.getElementById("contentOP").value;
		}
	}
}

/**
 * 预提交
 * @param action
 * @returns {Boolean}
 */
function executeWorkflowBefore(action) {
	if (!executeWorkflowBeforeEvent(action, summaryId, affairId, summaryObj.processId, summaryObj.processId, workflowObj.wfActivityId, formRecordid, workflowObj.moduleTypeName)) {
		return false;
	}
	return true;
}

//检查第三方高级表单
function checkFormThirdSubmit(jsonSubmitCallBack, action, commentVal, dialog) {
	jsonSubmitCallBack();
	// V50_SP2_NC业务集成插件_001_表单开发高级
	//formDevelopAdance4ThirdParty(bodyType, affairId, "repeal", commentVal, dialog, jsonSubmitCallBack);
	return true;
}

/*
 * 表单开发高级 : V50_SP2_NC业务集成插件_001_表单开发高级 @param bodyType ：正文类型 @param affairId
 * :affairId @param attitude :态度 @param opinionContent ：意见内容 @param
 * currentDialogWindowObj ：当前Dialog对象
 */
function formDevelopAdance4ThirdParty(bodyType, affairId, attitude, opinionContent, currentDialogWindowObj, succesCallBack) {
	try {
		function failedCallBack() {
			submit_callBack_failed();
		}
		beforeSubmit(affairId, $.trim(attitude), $.trim(opinionContent), currentDialogWindowObj, succesCallBack, failedCallBack);
	} catch (e) {
		alert($.i18n("govdoc.expection.form.advanced"));
	}
}


function policyContains(operation) {
	if ((nodePerm_commonActionList && nodePerm_commonActionList
			.contains(operation))
			|| (nodePerm_advanceActionList && nodePerm_advanceActionList
					.contains(operation))) {
		return true;
	}
	return false;
}

// 正文保存失败
function mainbody_callBack_failed() {
	enableOperation();
	setButtonCanUseReady();
	subCount = 0;
	try { hideMask(); } catch (e) { }
	return;
}

//提交不成功回调方法
function submit_callBack_failed(wfAction) {
	enableOperation();
	setButtonCanUseReady();
	if(wfAction) {
		var reg=/^\d+(\.\d+)?$/; 
		if(reg.test(wfAction)){
			releaseWorkflowByAction(summaryObj.processId, gCurrentUser.id, wfAction);
		}
	}
	try { hideMask(); } catch (e) {}
	try { subCount = 0; } catch (e) {}
	// 触发事件, 通知回滚包装数据
    $.ctp.trigger("operationRollbackEvent", {});
}

//验证不通过回调方法
function check_callBack_failed() {
	enableOperation();
	setButtonCanUseReady();
	try { hideMask(); } catch (e) {}
}

function addOneSub(n) {
	return parseInt(n) + 1;
}
function refreshComment(){
	$("#comment_deal #content").val($("#content_deal_comment").val());
}